//----------------------------------------------------------------------------
//
// DETL - A template library 1.0 beta
//
// Douglas Eleveld (D.J.Eleveld@anest.azg.nl)
//
//----------------------------------------------------------------------------

// Pentium cycle couting timer example and test

#include "penttime.h"

int main (void)
   {
   printf("Testing of pentium cycle timer\n\n");

   int acycles, a2cycles, bcycles, over;
   double a, b, c = 123456789.0, d = 999.0;

   pentium_timer cycle;
   over = cycle.overhead();

   // Getting the first results i.e. not in the cache?
   cycle.start();
   a = sqrt(d);
   cycle.stop();
   acycles = cycle.cycles();

   // Getting the second results i.e. in the cache?
   cycle.start();
   a = sqrt(c);
   cycle.stop();
   a2cycles = cycle.cycles();

   b = pow(d, 0.5);        /* get b & pow code into cache */
   cycle.start();
   b = pow(c, 0.5);
   cycle.stop();
   bcycles = cycle.cycles();

   printf ("overhead %i cycles\n",over);
   printf ("a = sqrt(c): first time, not in cache? = %d cycles \n", acycles);
   printf ("a = sqrt(c): second time, in cache? = %d cycles \n", a2cycles);
   printf ("b = pow(c, 0.5): %d cycles\n", bcycles);
   printf ("a = %f, b = %f\n", a, b); /* check results */
   /* and prevent optimizer from eliminating code under test */

   return(0);
   }

