//------------------------------------------------------------------------------
//		Log file header file
//------------------------------------------------------------------------------
#ifndef	LOGFILE_HEADER
#define	LOGFILE_HEADER
//------------------------------------------------------------------------------
#include <stdio.h>
//------------------------------------------------------------------------------
class logfile
			{
			private:
					// File information
					char filename[20];
					FILE *stream;

			protected:

			public:
					// Constructors and destructor
					logfile (void)                 { direct(NULL,0); };
					logfile (const char *n, int i) { direct(n,i); };
					~logfile();

               // Where to send the messages
               void direct (const char*, int = 0);

					// Logging functions
					logfile &operator << (const bool);
					logfile &operator << (const char);
					logfile &operator << (const char*);
					logfile &operator << (const float);
					logfile &operator << (const int);
					logfile &operator << (const unsigned);
					logfile &operator << (const long);
					logfile &operator << (const unsigned long);

					void close (void);
					void flush (void);
			};
//------------------------------------------------------------------------------
// Global log file
extern logfile stdlog;

//------------------------------------------------------------------------------
// Some defines to make logging easier

#define Log(x)   stdlog<<#x" = "<<x<<"\n"
#define TLog(x)  stdlog<<#x" = "<<x<<" in "<<__FILE__<<" ("<<__LINE__<<") "<<__PRETTY_FUNCTION__<<"\n"
#define FLog(x)  stdlog<<__PRETTY_FUNCTION__<<"\n"
#define LLog(x)  stdlog<<"line "<<__LINE__<<"\n"
#define VLLog(x) stdlog<<#x" = "<<x<<" at line "<<__LINE__<<"\n"
#define VFLog(x) stdlog<<#x" = "<<x<<" in "<<__PRETTY_FUNCTION__<<" line "<<__LINE__<<"\n"

//------------------------------------------------------------------------------
#endif
