//----------------------------------------------------------------------------
//
// DETL - A template library 1.0 beta
//
// Douglas Eleveld (D.J.Eleveld@anest.azg.nl)
//
//----------------------------------------------------------------------------

//----------------------------------------------------------------------------
// Basic container helper stuff
//----------------------------------------------------------------------------
#ifndef CONTAINER_HELPER_HEADER
#define CONTAINER_HELPER_HEADER
//----------------------------------------------------------------------------
// Base class for iteration with one argument
template <class T> class Titer_function
      {
      private:
            // The actual function
            void (*function)(const T&,void*);

      public:
            // Constructor
            Titer_function (void(*func)(const T&,void*)) { function = func; };

            Titer_function<T>& operator=(void(*func)(const T&,void*)) { function = func; return *this; };

            // Execute the function
            void operator()(const T& one, void *args) const { function(one,args); };
      };

//----------------------------------------------------------------------------
// Base class for comparison of two objects
template <class T> class Tcompare_function
      {
      private:
            // The actual function
            int (*compare)(const T&,void*);

      public:
            // Constructor
            Tcompare_function (int(*func)(const T&,void*)) { compare = func; };

            Tcompare_function<T>& operator=(int(*func)(const T&,void*)) { compare = func; return *this; };

            // Execute the compare
            int operator()(const T& one, void *args) const { return compare(one,args); };
      };

//----------------------------------------------------------------------------
#endif
