//----------------------------------------------------------------------------
//
// DETL - A template library 1.0 beta
//
// Douglas Eleveld (D.J.Eleveld@anest.azg.nl)
//
//----------------------------------------------------------------------------

//----------------------------------------------------------------------------
// Base class for guaranteed object delete at program exit
//----------------------------------------------------------------------------
#include <stdlib.h>
#include "guar_del.h"

//----------------------------------------------------------------------------
// Instance of list of created objects
bool guaranteed_delete::initialized = false;
guaranteed_delete** guaranteed_delete::objects = NULL;
int guaranteed_delete::number = 0;

//----------------------------------------------------------------------------
// Cleanup all objects that are not allready deleted
void exit_cleanup (void)
   {
   // Only start checking objects if we have been initialized
   if(guaranteed_delete::initialized==false) return;

   for(int i=0;i<guaranteed_delete::number;i++)
      {
      delete guaranteed_delete::objects[i];
      }

   delete [] guaranteed_delete::objects;
   }
//----------------------------------------------------------------------------
// Conctructor
guaranteed_delete::guaranteed_delete (void)
   {
   // Only start checking objects if we have been initialized
   if(initialized==false) return;

   // Setup the atexit stuff on the first create
   if(objects==NULL) atexit(exit_cleanup);

   // Allocate more room
   guaranteed_delete **newobjects = new (guaranteed_delete*)[number+1];
   if(newobjects==NULL) return;

   // Copy the old stuff over
   for(int i=0;i<number;i++) newobjects[i] = objects[i];
   newobjects[number] = this;
   number++;
   objects = newobjects;
   }
//----------------------------------------------------------------------------
// Destructor
guaranteed_delete::~guaranteed_delete (void)
   {
   // Only start checking objects if we have been initialized
   if(initialized==false) return;

   // Reduce the room used
   guaranteed_delete **newobjects = new (guaranteed_delete*)[number-1];
   if(newobjects==NULL) return;

   // Check the objects in the list
   int j = 0;
   for(int i=0;i<number;i++)
      {
      newobjects[i] = objects[j];

      // Have we found it?
      if(objects[i]!=this) j++;
      }
   delete [] objects;
   objects = newobjects;
   number--;
   }
//----------------------------------------------------------------------------

